require File.expand_path("../connection", __FILE__)
require File.expand_path("../request", __FILE__)

module RendertronRuby
  class Client
    include Connection
    include Request

    DEFAULT_HOST = 'localhost:3000'.freeze
    DEFAULT_SCHEME = 'https'.freeze
    DEFAULT_RENDER_PATH = '/render'.freeze
    DEFAULT_SS_PATH = '/screenshot'.freeze

    attr_reader *Configuration::VALID_OPTIONS

    def initialize(options)
      @host = options[:host] || default_host
      @scheme = options[:scheme] || default_scheme
      @render_path = options[:render_path] || default_render_path
      @ss_path = options[:ss_path] || default_ss_path
    end

    def get(url)
      request(:get, "#{render_path}/#{url}")
    end

    def get_ss(url)
      request(:get, "#{ss_path}/#{url}")
    end

    private

    def default_host
      DEFAULT_HOST
    end

    def default_scheme
      DEFAULT_SCHEME
    end

    def default_render_path
      DEFAULT_RENDER_PATH
    end

    def default_ss_path
      DEFAULT_SS_PATH
    end
  end
end
